"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthService = void 0;
const common_1 = require("@nestjs/common");
const microservices_1 = require("@nestjs/microservices");
const terminus_1 = require("@nestjs/terminus");
const health_module_definition_1 = require("../health-module-definition");
const indicators_1 = require("../indicators");
let HealthService = class HealthService {
    constructor(options, health, http, db, bull, microservice) {
        this.options = options;
        this.health = health;
        this.http = http;
        this.db = db;
        this.bull = bull;
        this.microservice = microservice;
    }
    check() {
        var _a, _b;
        const indicatorFunctions = [];
        indicatorFunctions.push(() => this.http.pingCheck(this.options.app, this.options.backendUrl));
        if (this.options.shouldCheckDatabase) {
            indicatorFunctions.push(() => this.db.pingCheck('database'));
        }
        if (this.options.redisOptions) {
            indicatorFunctions.push(() => this.microservice.pingCheck('redis', {
                transport: microservices_1.Transport.REDIS,
                options: this.options.redisOptions,
                timeout: 5000,
            }));
        }
        if ((_a = this.options.queueNames) === null || _a === void 0 ? void 0 : _a.length) {
            indicatorFunctions.push(() => this.bull.isHealthy(this.options.queueNames));
        }
        if ((_b = this.options.indicatorFunctions) === null || _b === void 0 ? void 0 : _b.length) {
            indicatorFunctions.push(...this.options.indicatorFunctions);
        }
        return this.health.check(indicatorFunctions);
    }
};
HealthService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(health_module_definition_1.MODULE_OPTIONS_TOKEN)),
    __metadata("design:paramtypes", [Object, terminus_1.HealthCheckService,
        terminus_1.HttpHealthIndicator,
        terminus_1.TypeOrmHealthIndicator,
        indicators_1.BullQueueHealthIndicator,
        terminus_1.MicroserviceHealthIndicator])
], HealthService);
exports.HealthService = HealthService;
//# sourceMappingURL=health.service.js.map